export function formatMs(milliseconds) {
  if (!Number.isFinite(milliseconds)) {
    return 'NaN';
  }

  var absInput = Math.abs(Math.round(milliseconds));
  var millis = (absInput % 1000).toString();

  if (millis.length < 3) {
    if (millis.length === 2) {
      millis = '0' + millis;
    } else {
      millis = '00' + millis;
    }
  }

  var seconds = Math.floor(absInput / 1000) % 60;
  var minutes = Math.floor(absInput / 60000);
  var output = "".concat(seconds, ".").concat(millis, "s");

  if (minutes > 0) {
    output = "".concat(minutes, "m").concat(output);
  }

  if (milliseconds < 0) {
    output = "-".concat(output);
  }

  return output;
}