import { Selector } from '@reduxjs/toolkit';
import { ReactNode, PureComponent } from 'react';
import { RtkResourceInfo, RTKStatusFlags } from '../types';
declare type QueryTimings = {
    startedAt: string;
    loadedAt: string;
    duration: string;
};
declare type FormattedQuery = {
    key: string;
    reducerPath: string;
    timings: QueryTimings;
    statusFlags: RTKStatusFlags;
} & ({
    mutation: RtkResourceInfo['state'];
} | {
    query: RtkResourceInfo['state'];
});
export interface QueryPreviewInfoProps {
    resInfo: RtkResourceInfo;
    isWideLayout: boolean;
}
export declare class QueryPreviewInfo extends PureComponent<QueryPreviewInfoProps> {
    shouldExpandNode: (keyPath: (string | number)[], value: unknown, layer: number) => boolean;
    selectFormattedQuery: Selector<RtkResourceInfo, FormattedQuery>;
    render(): ReactNode;
}
export {};
